#ifndef FORMAT_H
#define FORMAT_H


#include <cstddef>
#include <cstdint>
#include <cstring>  // memmove


class Format
{
public:
    explicit Format(void *p, size_t s = 0) : fp_(static_cast<uint8_t *>(p)), size_(s) {};

    virtual ~Format() {};

    virtual size_t Leanify(size_t size_leanified = 0)
    {
        if (size_leanified)
        {
            memmove(fp_ - size_leanified, fp_, size_);
            fp_ -= size_leanified;
        }

        return size_;
    }

protected:
    // pointer to the file content
    uint8_t *fp_;
    // size of the file
    size_t size_;
};


#endif